#include "opencv2/opencv.hpp"

#include "../hist_hue_sat.hpp"

int main() {
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("histogram", cv::WINDOW_AUTOSIZE);

    cv::VideoCapture cap(0);
    cv::Mat input, input_hsv;
    cv::Mat disp_hist(256, 256 * 2 + 1, CV_8UC3);

    HistHueSat histogram;
    histogram.visualizeLegend(disp_hist(cv::Rect(0, 0, 256, 256)));

    while (1) {
        cap >> input;
        cv::cvtColor(input, input_hsv, CV_BGR2HSV);

        histogram.calc(input_hsv);
        histogram.visualize(disp_hist(cv::Rect(256 + 1, 0, 256, 256)));

        cv::imshow("input", input);
        cv::imshow("histogram", disp_hist);

        int key;
        if ((key = cv::waitKey(30)) > 0) {
            if (key == 'q' || key == 0x1b) {
                break;  
            }
        }
    }

    return 0;
}
